/*
** Odin 2 Synthesizer Plugin
** Copyright (C) 2020 TheWaveWarden
**
** Odin 2 is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation, either version 3 of the License, or
** (at your option) any later version.
**
** Odin 2 is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
*/

//============================================================================
//============================================================================
//============================================================================
//============================================================================
//============================================================================
//============================== IDENTIFIERS =================================
//============================================================================
//============================================================================
//============================================================================
//============================================================================
//============================================================================

m_osc1_type_identifier("osc1_type"), m_osc2_type_identifier("osc2_type"),
    m_osc3_type_identifier("osc3_type"), m_osc1_oct_identifier("osc1_oct"),
    m_osc2_oct_identifier("osc2_oct"), m_osc3_oct_identifier("osc3_oct"),
    m_osc1_semi_identifier("osc1_semi"), m_osc2_semi_identifier("osc2_semi"),
    m_osc3_semi_identifier("osc3_semi"), m_osc1_fine_identifier("osc1_fine"),
    m_osc2_fine_identifier("osc2_fine"), m_osc3_fine_identifier("osc3_fine"),
    m_osc1_analog_wave_identifier("osc1_analog_wave"),
    m_osc2_analog_wave_identifier("osc2_analog_wave"),
    m_osc3_analog_wave_identifier("osc3_analog_wave"),
    m_osc1_vol_identifier("osc1_vol"), m_osc2_vol_identifier("osc2_vol"),
    m_osc3_vol_identifier("osc3_vol"),
    m_osc1_position_identifier("osc1_position"),
    m_osc2_position_identifier("osc2_position"),
    m_osc3_position_identifier("osc3_position"),
    m_osc1_detune_identifier("osc1_detune"),
    m_osc2_detune_identifier("osc2_detune"),
    m_osc3_detune_identifier("osc3_detune"),
    m_osc1_pos_env_identifier("osc1_pos_mod"),
    m_osc2_pos_env_identifier("osc2_pos_mod"),
    m_osc3_pos_env_identifier("osc3_pos_mod"),
    m_osc1_multi_position_identifier("osc1_multi_position"),
    m_osc2_multi_position_identifier("osc2_multi_position"),
    m_osc3_multi_position_identifier("osc3_multi_position"),
    m_osc1_spread_identifier("osc1_spread"),
    m_osc2_spread_identifier("osc2_spread"),
    m_osc3_spread_identifier("osc3_spread"),
    m_osc1_pulsewidth_identifier("osc1_pulsewidth"),
    m_osc2_pulsewidth_identifier("osc2_pulsewidth"),
    m_osc3_pulsewidth_identifier("osc3_pulsewidth"),
    m_osc1_drift_identifier("osc1_drift"),
    m_osc2_drift_identifier("osc2_drift"),
    m_osc3_drift_identifier("osc3_drift"),
    m_osc1_arp_speed_identifier("osc1_arp_speed"),
    m_osc2_arp_speed_identifier("osc2_arp_speed"),
    m_osc3_arp_speed_identifier("osc3_arp_speed"),
    m_osc1_step_1_identifier("osc1_step_1"),
    m_osc2_step_1_identifier("osc2_step_1"),
    m_osc3_step_1_identifier("osc3_step_1"),
    m_osc1_step_2_identifier("osc1_step_2"),
    m_osc2_step_2_identifier("osc2_step_2"),
    m_osc3_step_2_identifier("osc3_step_2"),
    m_osc1_step_3_identifier("osc1_step_3"),
    m_osc2_step_3_identifier("osc2_step_3"),
    m_osc3_step_3_identifier("osc3_step_3"), m_osc1_fm_identifier("osc1_fm"),
    m_osc2_fm_identifier("osc2_fm"), m_osc3_fm_identifier("osc3_fm"),
    m_osc1_carrier_ratio_identifier("osc1_carrier_ratio"),
    m_osc2_carrier_ratio_identifier("osc2_carrier_ratio"),
    m_osc3_carrier_ratio_identifier("osc3_carrier_ratio"),
    m_osc1_carrier_wave_identifier("osc1_carrier_wave"),
    m_osc2_carrier_wave_identifier("osc2_carrier_wave"),
    m_osc3_carrier_wave_identifier("osc3_carrier_wave"),
    m_osc1_modulator_wave_identifier("osc1_modulator_wave"),
    m_osc2_modulator_wave_identifier("osc2_modulator_wave"),
    m_osc3_modulator_wave_identifier("osc3_modulator_wave"),
    m_osc1_modulation_source_identifier("osc1_mod_source"),
    m_osc2_modulation_source_identifier("osc2_mod_source"),
    m_osc3_modulation_source_identifier("osc3_mod_source"),
    m_osc1_modulator_ratio_identifier("osc1_modulator_ratio"),
    m_osc2_modulator_ratio_identifier("osc2_modulator_ratio"),
    m_osc3_modulator_ratio_identifier("osc3_modulator_ratio"),
    m_osc1_lp_identifier("osc1_lp"), m_osc2_lp_identifier("osc2_lp"),
    m_osc3_lp_identifier("osc3_lp"), m_osc1_hp_identifier("osc1_hp"),
    m_osc2_hp_identifier("osc2_hp"), m_osc3_hp_identifier("osc3_hp"),
    m_osc1_reset_identifier("osc1_reset"),
    m_osc2_reset_identifier("osc2_reset"),
    m_osc3_reset_identifier("osc3_reset"),
    m_osc2_sync_identifier("osc2_sync"),
    m_osc3_sync_identifier("osc3_sync"),
    m_osc1_arp_on_identifier("osc1_arp_on"),
    m_osc2_arp_on_identifier("osc2_arp_on"),
    m_osc3_arp_on_identifier("osc3_arp_on"),
    m_osc1_step_3_on_identifier("osc1_step_3_on"),
    m_osc2_step_3_on_identifier("osc2_step_3_on"),
    m_osc3_step_3_on_identifier("osc3_step_3_on"),
    m_osc1_chipnoise_identifier("osc1_chipnoise"),
    m_osc2_chipnoise_identifier("osc2_chipnoise"),
    m_osc3_chipnoise_identifier("osc3_chipnoise"),
    m_osc1_chipwave_identifier("osc1_chipwave"),
    m_osc2_chipwave_identifier("osc2_chipwave"),
    m_osc3_chipwave_identifier("osc3_chipwave"),
    m_osc1_exp_fm_identifier("osc1_exp_fm"),
    m_osc2_exp_fm_identifier("osc2_exp_fm"),
    m_osc3_exp_fm_identifier("osc3_exp_fm"),
    m_osc1_vec_a_identifier("osc1_vec_a"),
    m_osc2_vec_a_identifier("osc2_vec_a"),
    m_osc3_vec_a_identifier("osc3_vec_a"),
    m_osc1_vec_b_identifier("osc1_vec_b"),
    m_osc2_vec_b_identifier("osc2_vec_b"),
    m_osc3_vec_b_identifier("osc3_vec_b"),
    m_osc1_vec_c_identifier("osc1_vec_c"),
    m_osc2_vec_c_identifier("osc2_vec_c"),
    m_osc3_vec_c_identifier("osc3_vec_c"),
    m_osc1_vec_d_identifier("osc1_vec_d"),
    m_osc2_vec_d_identifier("osc2_vec_d"),
    m_osc3_vec_d_identifier("osc3_vec_d"),
    m_osc1_vec_x_identifier("osc1_vec_x"),
    m_osc2_vec_x_identifier("osc2_vec_x"),
    m_osc3_vec_x_identifier("osc3_vec_x"),
    m_osc1_vec_y_identifier("osc1_vec_y"),
    m_osc2_vec_y_identifier("osc2_vec_y"),
    m_osc3_vec_y_identifier("osc3_vec_y"),
    m_osc1_wavetable_identifier("osc1_wavetable"),
    m_osc2_wavetable_identifier("osc2_wavetable"),
    m_osc3_wavetable_identifier("osc3_wavetable"),
    m_fil1_type_identifier("fil1_type"), m_fil2_type_identifier("fil2_type"),
    m_fil3_type_identifier("fil3_type"), m_fil1_vel_identifier("fil1_vel"),
    m_fil2_vel_identifier("fil2_vel"), m_fil3_vel_identifier("fil3_vel"),
    m_fil1_kbd_identifier("fil1_kbd"), m_fil2_kbd_identifier("fil2_kbd"),
    m_fil3_kbd_identifier("fil3_kbd"), m_fil1_env_identifier("fil1_env"),
    m_fil2_env_identifier("fil2_env"), m_fil3_env_identifier("fil3_env"),
    m_fil1_gain_identifier("fil1_gain"), m_fil2_gain_identifier("fil2_gain"),
    m_fil3_gain_identifier("fil3_gain"), m_fil1_freq_identifier("fil1_freq"),
    m_fil2_freq_identifier("fil2_freq"), m_fil3_freq_identifier("fil3_freq"),
    m_fil1_res_identifier("fil1_res"), m_fil2_res_identifier("fil2_res"),
    m_fil3_res_identifier("fil3_res"),
    m_fil1_saturation_identifier("fil1_saturation"),
    m_fil2_saturation_identifier("fil2_saturation"),
    m_fil3_saturation_identifier("fil3_saturation"),
    m_fil1_formant_transition_identifier("fil1_formant_transition"),
    m_fil2_formant_transition_identifier("fil2_formant_transition"),
    m_fil3_formant_transition_identifier("fil3_formant_transition"),
    m_fil1_ring_mod_amount_identifier("fil1_ring_mod_amount"),
    m_fil2_ring_mod_amount_identifier("fil2_ring_mod_amount"),
    m_fil3_ring_mod_amount_identifier("fil3_ring_mod_amount"),
    m_fil1_sem_transition_identifier("fil1_sem_transition"),
    m_fil2_sem_transition_identifier("fil2_sem_transition"),
    m_fil3_sem_transition_identifier("fil3_sem_transition"),
    m_fil1_vowel_left_identifier("fil1_vowel_left"),
    m_fil2_vowel_left_identifier("fil2_vowel_left"),
    m_fil3_vowel_left_identifier("fil3_vowel_left"),
    m_fil1_vowel_right_identifier("fil1_vowel_right"),
    m_fil2_vowel_right_identifier("fil2_vowel_right"),
    m_fil3_vowel_right_identifier("fil3_vowel_right"),
    m_fil1_comb_polarity_identifier("fil1_comb_polarity"),
    m_fil2_comb_polarity_identifier("fil2_comb_polarity"),
    m_fil3_comb_polarity_identifier("fil3_comb_polarity"),
    m_amp_pan_identifier("amp_pan"), m_amp_gain_identifier("amp_gain"),
    m_amp_velocity_identifier("amp_velocity"),
    m_dist_threshold_identifier("dist_boost"),
    m_dist_drywet_identifier("dist_drywet"), 
    m_dist_on_identifier("dist_on"),
    m_arp_synctime_denominator_identifier("arp_synctime_denominator"),
    m_arp_synctime_numerator_identifier("arp_synctime_numerator"),
    m_arp_octaves_identifier("arp_octaves"),
    m_arp_direction_identifier("arp_direction"),
    m_arp_steps_identifier("arp_steps"),
    m_arp_gate_identifier("arp_gate"),
    m_dist_algo_identifier("dist_algo"),
    m_fil1_to_amp_identifier("fil1_to_amp"),
    m_fil2_to_amp_identifier("fil2_to_amp"),
    m_env1_attack_identifier("env1_attack"),
    m_env1_decay_identifier("env1_decay"),
    m_env1_sustain_identifier("env1_sustain"),
    m_env1_release_identifier("env1_release"),
    m_env1_loop_identifier("env1_loop"),
    m_env2_attack_identifier("env2_attack"),
    m_env2_decay_identifier("env2_decay"),
    m_env2_sustain_identifier("env2_sustain"),
    m_env2_release_identifier("env2_release"),
    m_env2_loop_identifier("env2_loop"),
    m_env3_attack_identifier("env3_attack"),
    m_env3_decay_identifier("env3_decay"),
    m_env3_sustain_identifier("env3_sustain"),
    m_env3_release_identifier("env3_release"),
    m_env3_loop_identifier("env3_loop"),
    m_env4_attack_identifier("env4_attack"),
    m_env4_decay_identifier("env4_decay"),
    m_env4_sustain_identifier("env4_sustain"),
    m_env4_release_identifier("env4_release"),
    m_env4_loop_identifier("env4_loop"), m_lfo1_freq_identifier("lfo1_freq"),
    m_lfo1_reset_identifier("lfo1_reset"), m_lfo1_sync_identifier("lfo1_sync"),
    m_lfo1_wave_identifier("lfo1_wave"),
    m_lfo1_synctime_numerator_identifier("lfo1_synctime_numerator"),
    m_lfo1_synctime_denominator_identifier("lfo1_synctime_denominator"),
    m_lfo2_freq_identifier("lfo2_freq"), m_lfo2_reset_identifier("lfo2_reset"),
    m_lfo2_sync_identifier("lfo2_sync"), m_lfo2_wave_identifier("lfo2_wave"),
    m_lfo2_synctime_numerator_identifier("lfo2_synctime_numerator"),
    m_lfo2_synctime_denominator_identifier("lfo2_synctime_denominator"),
    m_lfo3_freq_identifier("lfo3_freq"), m_lfo3_reset_identifier("lfo3_reset"),
    m_lfo3_sync_identifier("lfo3_sync"), m_lfo3_wave_identifier("lfo3_wave"),
    m_lfo3_synctime_numerator_identifier("lfo3_synctime_numerator"),
    m_lfo3_synctime_denominator_identifier("lfo3_synctime_denominator"),
    m_lfo4_freq_identifier("lfo4_freq"), m_lfo4_reset_identifier("lfo4_reset"),
    m_lfo4_sync_identifier("lfo4_sync"), m_lfo4_wave_identifier("lfo4_wave"),
    m_lfo4_synctime_numerator_identifier("lfo4_synctime_numerator"),
    m_lfo4_synctime_denominator_identifier("lfo4_synctime_denominator"),
    m_glide_identifier("glide"), m_master_identifier("master"),
    m_legato_identifier("legato"), m_modwheel_identifier("modwheel"),
    m_pitchbend_identifier("pitchbend"),
    m_pitchbend_amount_identifier("pitchbend_amount"),
    m_unison_voices_identifier("unison_voices"),
    m_unison_width_identifier("unison_width"),
    m_unison_detune_identifier("unison_detune"),
    m_xy_x_identifier("xy_x"), m_xy_y_identifier("xy_y"),
    m_delay_on_identifier("delay_on"), m_phaser_on_identifier("phaser_on"),
    m_flanger_on_identifier("flanger_on"), m_chorus_on_identifier("chorus_on"),
    m_delay_selected_identifier("delay_selected"),
    m_phaser_selected_identifier("phaser_selected"),
    m_flanger_selected_identifier("flanger_selected"),
    m_chorus_selected_identifier("chorus_selected"),
    m_fil1_osc1_identifier("fil1_osc1"), m_fil1_osc2_identifier("fil1_osc2"),
    m_fil1_osc3_identifier("fil1_osc3"), m_fil2_osc1_identifier("fil2_osc1"),
    m_fil2_osc2_identifier("fil2_osc2"), m_fil2_osc3_identifier("fil2_osc3"),
    m_fil2_fil1_identifier("fil2_fil1"),
    m_delay_position_identifier("delay_position"),
    m_flanger_position_identifier("flanger_position"),
    m_phaser_position_identifier("phaser_position"),
    m_chorus_position_identifier("chorus_position"),
    m_delay_time_identifier("delay_time"),
    m_delay_feedback_identifier("delay_feedback"),
    m_delay_hp_identifier("delay_hp"),
    m_delay_ducking_identifier("delay_ducking"),
    m_delay_dry_identifier("delay_dry"), m_delay_wet_identifier("delay_wet"),
    m_delay_sync_identifier("delay_sync"),
    m_delay_pingpong_identifier("delay_pingpong"),
    m_delay_synctime_numerator_identifier("delay_synctime_numerator"),
    m_delay_synctime_denominator_identifier("delay_synctime_denominator"),
    m_phaser_reset_identifier("phaser_reset"),
    m_arp_on_identifier("arp_on"),
    m_arp_one_shot_identifier("arp_one_shot"),
    m_step_0_on_identifier("step_0_on"),
    m_step_1_on_identifier("step_1_on"),
    m_step_2_on_identifier("step_2_on"),
    m_step_3_on_identifier("step_3_on"),
    m_step_4_on_identifier("step_4_on"),
    m_step_5_on_identifier("step_5_on"),
    m_step_6_on_identifier("step_6_on"),
    m_step_7_on_identifier("step_7_on"),
    m_step_8_on_identifier("step_8_on"),
    m_step_9_on_identifier("step_9_on"),
    m_step_10_on_identifier("step_10_on"),
    m_step_11_on_identifier("step_11_on"),
    m_step_12_on_identifier("step_12_on"),
    m_step_13_on_identifier("step_13_on"),
    m_step_14_on_identifier("step_14_on"),
    m_step_15_on_identifier("step_15_on"),

    m_step_0_mod_1_identifier("step_0_mod_1"),
    m_step_1_mod_1_identifier("step_1_mod_1"),
    m_step_2_mod_1_identifier("step_2_mod_1"),
    m_step_3_mod_1_identifier("step_3_mod_1"),
    m_step_4_mod_1_identifier("step_4_mod_1"),
    m_step_5_mod_1_identifier("step_5_mod_1"),
    m_step_6_mod_1_identifier("step_6_mod_1"),
    m_step_7_mod_1_identifier("step_7_mod_1"),
    m_step_8_mod_1_identifier("step_8_mod_1"),
    m_step_9_mod_1_identifier("step_9_mod_1"),
    m_step_10_mod_1_identifier("step_10_mod_1"),
    m_step_11_mod_1_identifier("step_11_mod_1"),
    m_step_12_mod_1_identifier("step_12_mod_1"),
    m_step_13_mod_1_identifier("step_13_mod_1"),
    m_step_14_mod_1_identifier("step_14_mod_1"),
    m_step_15_mod_1_identifier("step_15_mod_1"),

    m_step_0_mod_2_identifier("step_0_mod_2"),
    m_step_1_mod_2_identifier("step_1_mod_2"),
    m_step_2_mod_2_identifier("step_2_mod_2"),
    m_step_3_mod_2_identifier("step_3_mod_2"),
    m_step_4_mod_2_identifier("step_4_mod_2"),
    m_step_5_mod_2_identifier("step_5_mod_2"),
    m_step_6_mod_2_identifier("step_6_mod_2"),
    m_step_7_mod_2_identifier("step_7_mod_2"),
    m_step_8_mod_2_identifier("step_8_mod_2"),
    m_step_9_mod_2_identifier("step_9_mod_2"),
    m_step_10_mod_2_identifier("step_10_mod_2"),
    m_step_11_mod_2_identifier("step_11_mod_2"),
    m_step_12_mod_2_identifier("step_12_mod_2"),
    m_step_13_mod_2_identifier("step_13_mod_2"),
    m_step_14_mod_2_identifier("step_14_mod_2"),
    m_step_15_mod_2_identifier("step_15_mod_2"),

    m_step_0_transpose_identifier("step_0_transpose"),
    m_step_1_transpose_identifier("step_1_transpose"),
    m_step_2_transpose_identifier("step_2_transpose"),
    m_step_3_transpose_identifier("step_3_transpose"),
    m_step_4_transpose_identifier("step_4_transpose"),
    m_step_5_transpose_identifier("step_5_transpose"),
    m_step_6_transpose_identifier("step_6_transpose"),
    m_step_7_transpose_identifier("step_7_transpose"),
    m_step_8_transpose_identifier("step_8_transpose"),
    m_step_9_transpose_identifier("step_9_transpose"),
    m_step_10_transpose_identifier("step_10_transpose"),
    m_step_11_transpose_identifier("step_11_transpose"),
    m_step_12_transpose_identifier("step_12_transpose"),
    m_step_13_transpose_identifier("step_13_transpose"),
    m_step_14_transpose_identifier("step_14_transpose"),
    m_step_15_transpose_identifier("step_15_transpose"),

    m_phaser_sync_identifier("phaser_sync"),
    m_phaser_rate_identifier("phaser_rate"),
    m_phaser_freq_identifier("phaser_freq"),
    m_phaser_feedback_identifier("phaser_feedback"),
    m_phaser_mod_identifier("phaser_mod"),
    m_phaser_drywet_identifier("phaser_drywet"),
    m_phaser_synctime_numerator_identifier("phaser_synctime_numerator"),
    m_phaser_synctime_denominator_identifier("phaser_synctime_denominator"),
    m_flanger_reset_identifier("flanger_reset"),
    m_flanger_sync_identifier("flanger_sync"),
    m_flanger_rate_identifier("flanger_rate"),
    m_flanger_amount_identifier("flanger_amount"),
    m_flanger_drywet_identifier("flanger_drywet"),
    m_flanger_feedback_identifier("flanger_feedback"),
    m_flanger_synctime_numerator_identifier("flanger_synctime_numerator"),
    m_flanger_synctime_denominator_identifier("flanger_synctime_denominator"),
    m_chorus_reset_identifier("chorus_reset"),
    m_chorus_sync_identifier("chorus_sync"),
    m_chorus_rate_identifier("chorus_rate"),
    m_chorus_amount_identifier("chorus_amount"),
    m_chorus_drywet_identifier("chorus_drywet"),
    m_chorus_feedback_identifier("chorus_feedback"),
    m_chorus_synctime_numerator_identifier("chorus_synctime_numerator"),
    m_chorus_synctime_denominator_identifier("chorus_synctime_denominator"),
    m_amount_1_row_1_identifier("amount_0_row_0"),
    m_amount_1_row_2_identifier("amount_0_row_1"),
    m_amount_1_row_3_identifier("amount_0_row_2"),
    m_amount_1_row_4_identifier("amount_0_row_3"),
    m_amount_1_row_5_identifier("amount_0_row_4"),
    m_amount_1_row_6_identifier("amount_0_row_5"),
    m_amount_1_row_7_identifier("amount_0_row_6"),
    m_amount_1_row_8_identifier("amount_0_row_7"),
    m_amount_1_row_9_identifier("amount_0_row_8"),
    m_amount_2_row_1_identifier("amount_1_row_0"),
    m_amount_2_row_2_identifier("amount_1_row_1"),
    m_amount_2_row_3_identifier("amount_1_row_2"),
    m_amount_2_row_4_identifier("amount_1_row_3"),
    m_amount_2_row_5_identifier("amount_1_row_4"),
    m_amount_2_row_6_identifier("amount_1_row_5"),
    m_amount_2_row_7_identifier("amount_1_row_6"),
    m_amount_2_row_8_identifier("amount_1_row_7"),
    m_amount_2_row_9_identifier("amount_1_row_8"),
    m_amount_3_row_1_identifier("amount_2_row_0"),
    m_amount_3_row_2_identifier("amount_2_row_1"),
    m_amount_3_row_3_identifier("amount_2_row_2"),
    m_amount_3_row_4_identifier("amount_2_row_3"),
    m_amount_3_row_5_identifier("amount_2_row_4"),
    m_amount_3_row_6_identifier("amount_2_row_5"),
    m_amount_3_row_7_identifier("amount_2_row_6"),
    m_amount_3_row_8_identifier("amount_2_row_7"),
    m_amount_3_row_9_identifier("amount_2_row_8"),
    m_source_row_1_identifier("source_row_0"),
    m_source_row_2_identifier("source_row_1"),
    m_source_row_3_identifier("source_row_2"),
    m_source_row_4_identifier("source_row_3"),
    m_source_row_5_identifier("source_row_4"),
    m_source_row_6_identifier("source_row_5"),
    m_source_row_7_identifier("source_row_6"),
    m_source_row_8_identifier("source_row_7"),
    m_source_row_9_identifier("source_row_8"),
    m_dest_1_row_1_identifier("dest_1_row_0"),
    m_dest_1_row_2_identifier("dest_1_row_1"),
    m_dest_1_row_3_identifier("dest_1_row_2"),
    m_dest_1_row_4_identifier("dest_1_row_3"),
    m_dest_1_row_5_identifier("dest_1_row_4"),
    m_dest_1_row_6_identifier("dest_1_row_5"),
    m_dest_1_row_7_identifier("dest_1_row_6"),
    m_dest_1_row_8_identifier("dest_1_row_7"),
    m_dest_1_row_9_identifier("dest_1_row_8"),
    m_dest_2_row_1_identifier("dest_2_row_0"),
    m_dest_2_row_2_identifier("dest_2_row_1"),
    m_dest_2_row_3_identifier("dest_2_row_2"),
    m_dest_2_row_4_identifier("dest_2_row_3"),
    m_dest_2_row_5_identifier("dest_2_row_4"),
    m_dest_2_row_6_identifier("dest_2_row_5"),
    m_dest_2_row_7_identifier("dest_2_row_6"),
    m_dest_2_row_8_identifier("dest_2_row_7"),
    m_dest_2_row_9_identifier("dest_2_row_8"),
    m_scale_row_1_identifier("scale_row_0"),
    m_scale_row_2_identifier("scale_row_1"),
    m_scale_row_3_identifier("scale_row_2"),
    m_scale_row_4_identifier("scale_row_3"),
    m_scale_row_5_identifier("scale_row_4"),
    m_scale_row_6_identifier("scale_row_5"),
    m_scale_row_7_identifier("scale_row_6"),
    m_scale_row_8_identifier("scale_row_7"),
    m_scale_row_9_identifier("scale_row_8"), m_BPM_identifier("BPM"), 
    m_value_tree_draw("draw"),
	m_value_tree_fx("fx"),
	m_value_tree_lfo("lfo"),
	m_value_tree_misc("misc"),
	m_value_tree_mod("mod"),
	m_value_tree_osc("osc"),
    m_value_tree_midi_learn("midi_learn")